/***************************************************************************
 *   Copyright (C) 2008-2011 by Andreas Winter   *
 *   andreas.f.winter@web.de   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "undo_module.h"
#include "MainWindow.h"
#include "allWidgets.h"
#include "globals.h"
#include "xprotos.h"

using namespace std;

extern graph *g;

extern MainWindow * mainWin;
extern frmUndoList * FormUndoList;
extern bool undo_active;
extern int used_Nodes;
extern int akt_Node;
extern int NodeNr;
extern int max_node_nr;
extern class undo_node * Node;
extern DrawProps draw_props;
extern frmAxisProp * FormAxisProperties;

char dummy[512];

//necessary for saving before and after state during modifications
int saved_prev_sets=0;
int saved_prev_graphs=0;
int saved_prev_tickmarks=0;
plotarr ** prev_sets=NULL;
graph ** prev_graphs=NULL;
tickmarks ** prev_tickmarks=NULL;
int old_data[16];//to store some data temporarely
double * old_ddata[16];//to store some data temporarely
int * old_idata[16];//to store some data temporarely
plotstr * old_tmstmp=NULL;
linetype * sav_lt=NULL;
boxtype * sav_bt=NULL;
ellipsetype * sav_et=NULL;
plotstr * sav_st=NULL;

bool wait_till_update=false;

undo_node::undo_node(void)
{
data=NULL;
    for (int i=0;i<MAX_DATA_IN_NODE;i++)
    {
    id[i]=NULL;
    ddata[i]=NULL;
    }
clearContents();//sets defaults
}

undo_node::~undo_node()
{
clearContents();
}

void undo_node::doStoreData(int type,void ** data)//noch nicht fertig
{

}

void undo_node::reStoreData(void)
{
int nid;
int offset;
linetype ** lt;
boxtype ** bt;
ellipsetype ** et;
plotstr ** st;
plotarr ** pa;
tickmarks ** tick;
graph ** gr;
char *ssav;
world w;
view v;
double * dd;
    switch (type)
    {
    case UNDO_TYPE_INVALID:
    break;
    case UNDO_TYPE_SET_SWAP:
    swapset(origin[0],origin[1],origin[2],origin[3]);
    break;
    case UNDO_TYPE_GRAPH_SWAP:
    swap_graph(origin[0],origin[3]);
    break;
    case UNDO_TYPE_PACK_SETS:
    realloc_graph_plots(origin[0],origin[2]);
    pa=(plotarr **) data;
        for (int i=0;i<origin[2];i++)
        {
        reinstallSet(origin[0],i,pa[i],UNDO_COMPLETE);
        }
    if (this->active!=true)//make a redo
    packsets(origin[0]);
    break;
    case UNDO_VIEWPORT_CHANGED:
        if (this->active==true)//not undone yet --> reinstall previous stuff
        offset=0;
        else//reinstall state after change
        offset=4;
        dd=(double*)data;
        v.xv1=dd[offset];
        v.xv2=dd[offset+1];
        v.yv1=dd[offset+2];
        v.yv2=dd[offset+3];
        set_graph_viewport(origin[0],v);
    break;
    case UNDO_TYPE_KILL_SET://reinstall set(s)
        pa=(plotarr **) data;
        for (int i=0;i<origin[2];i++)
        {
            if (is_set_active(id[0][i],id[1][i])==TRUE)//set exists -- this means, that the set-id hsa been reused
            {//get new set-id
            nid=nextset(id[0][i]);
            }
            else
            {//set-id can be used!
            nid=id[1][i];
            }
        id[1][i]=nid;
        reinstallSet(id[0][i],id[1][i],pa[i],origin[3]);
        }
    break;
    case UNDO_TYPE_NEW_SET://delete set(s)
        for (int i=0;i<origin[2];i++)
        {
        killset(id[0][i],id[1][i]);
        }
    break;
    case UNDO_TYPE_SET_MODIFIED:
    case UNDO_TYPE_SET_APPEARANCE:
        if (this->active==true)//not undone yet --> reinstall previous stuff
        {
        offset=0;
        nid=origin[1];
        }
        else//reinstall state after change
        {
        offset=origin[1];
        nid=origin[2];
        }

        pa=(plotarr **) data;
            if (nid==0)
            {
                for (int i=0;i<origin[2];i++)
                {
                killsetdata(id[0][i],id[1][i]);
                }
            }
            else
            {
                for (int i=0;i<nid;i++)//in this case: changing the set-ids is not apropriate
                {
                reinstallSet(id[0][i+offset],id[1][i+offset],pa[offset+i],origin[3]);
                    if (is_set_active(id[0][i+offset],id[1][i+offset])==FALSE)
                    {
                    set_set_hidden(id[0][i+offset],id[1][i+offset], FALSE);
                    }
                }
            }
    break;
    case UNDO_TYPE_GRAPH_APPEARANCE:///Graph Sachen fehlen!
        gr=(graph**)data;
        if (this->active==true)//not undone yet --> reinstall previous stuff
        {
        offset=0;
        nid=origin[1];
        }
        else//reinstall state after change
        {
        offset=origin[1];
        nid=origin[2];
        }
        //cout << "number_of_graphs=" << number_of_graphs() << " nid=" << nid << endl;
            while (number_of_graphs()>nid)
            kill_graph(number_of_graphs()-1);
            while (number_of_graphs()<nid)
            graph_allocate(number_of_graphs());
        for (int i=0;i<nid;i++)//in this case: changing the set-ids is not apropriate
        {
        reinstallGraph(id[0][i+offset],gr[offset+i],origin[3]);
        }
    break;
    case UNDO_TYPE_PLOT_APPEARANCE:
        st=(plotstr**)data;
        if (this->active==true)//not undone yet --> reinstall previous stuff
        offset=0;
        else//reinstall state after change
        offset=2;
        draw_props.bgcolor=origin[offset];
        draw_props.bgfilled=origin[offset+1];
        ssav=timestamp.s;
        memcpy(&timestamp,st[offset/2],sizeof(plotstr));
        timestamp.s=ssav;
    break;
    case UNDO_TYPE_OBJECT_MODIFIED:
    if (this->active==true)//not undone yet --> reinstall previous stuff
    offset=0;
    else//reinstall state after change
    offset=1;
    nid=origin[0];
        switch (origin[1])//type
        {
        case OBJECT_BOX:
        bt=(boxtype**)data;
            if (isactive_box(nid))
            memcpy(boxes+nid,bt[offset],sizeof(boxtype));
        break;
        case OBJECT_LINE:
        lt=(linetype**)data;
            if (isactive_line(nid))
            memcpy(lines+nid,lt[offset],sizeof(linetype));
        break;
        case OBJECT_ELLIPSE:
        et=(ellipsetype**)data;
            if (isactive_ellipse(nid))
            memcpy(ellip+nid,et[offset],sizeof(ellipsetype));
        break;
        case OBJECT_STRING:
        st=(plotstr**)data;
            if (isactive_string(nid))
            {
            memcpy(pstr+nid,st[offset],sizeof(plotstr));
                if (pstr[nid].s!=NULL)
                {
                pstr[nid].s=copy_string(NULL,(st[offset])->s);
                }
            }
        break;
        }
    break;
    case UNDO_TYPE_PAGE_SETUP:
    break;
    case UNDO_TYPE_AXIS_PROPERTIES:
        tick=(tickmarks **)data;
        if (this->active==true)//not undone yet --> reinstall previous stuff
        offset=0;
        else//reinstall state after change
        offset=origin[2];

        //cout << "offset=" << offset << endl;

        //id[0][0]=axis_start;
        //id[0][1]=axis_stop;
        //id[0][2]=graph_start;
        //id[0][3]=graph_stop;

        for (int i=id[0][2];i<=id[0][3];i++)//graphs
        {
            for (int j=id[0][0];j<=id[0][1];j++)//axes
            {
            set_graph_tickmarks(i,j,tick[offset]);
            w.xg1=ddata[0][offset];
            w.xg2=ddata[1][offset];
            w.yg1=ddata[2][offset];
            w.yg2=ddata[3][offset];
            g[i].xscale = id[1][4*offset+0];
            g[i].yscale = id[1][4*offset+1];
            g[i].xinvert = id[1][4*offset+2];
            g[i].yinvert = id[1][4*offset+3];
            offset++;
            }
            //set_graph_xscale(i,id[1][4*offset+0]);
            //set_graph_yscale(i,id[1][4*offset+1]);
            set_graph_world(i, w);
        }
        if (FormAxisProperties!=NULL)
        FormAxisProperties->update_ticks(get_cg());

        //cout << "offset=" << offset << endl;
    break;
    case UNDO_TYPE_NEW_ORDERING:
    break;
    case UNDO_FIT:
    break;
    case UNDO_REGION:
    break;
    case UNDO_TYPE_OBJECT_INSERTED:
        for (int i=0;i<origin[2];i++)
        {
            switch (origin[1])//type
            {
            case OBJECT_BOX:
            kill_box(id[0][i]);
            break;
            case OBJECT_LINE:
            kill_line(id[0][i]);
            break;
            case OBJECT_ELLIPSE:
            kill_ellipse(id[0][i]);
            break;
            case OBJECT_STRING:
            kill_string(id[0][i]);
            break;
            }
        }
    break;
    case UNDO_TYPE_OBJECT_DELETED:
        switch (origin[1])//type
        {
        case OBJECT_BOX:
        bt=(boxtype**)data;
            for (int i=0;i<origin[2];i++)
            {
            nid=next_box();
            id[0][i]=nid;
            memcpy(boxes+nid,bt[i],sizeof(boxtype));
            }
        break;
        case OBJECT_LINE:
        lt=(linetype**)data;
            for (int i=0;i<origin[2];i++)
            {
            nid=next_line();
            id[0][i]=nid;
            memcpy(lines+nid,lt[i],sizeof(linetype));
            }
        break;
        case OBJECT_ELLIPSE:
        et=(ellipsetype**)data;
            for (int i=0;i<origin[2];i++)
            {
            nid=next_ellipse();
            id[0][i]=nid;
            memcpy(ellip+nid,et[i],sizeof(ellipsetype));
            }
        break;
        case OBJECT_STRING:
        st=(plotstr**)data;
            for (int i=0;i<origin[2];i++)
            {
            nid=next_string();
            id[0][i]=nid;
            memcpy(pstr+nid,st[i],sizeof(plotstr));
                if (pstr[nid].s!=NULL)
                {
                pstr[nid].s=copy_string(NULL,(st[i])->s);
                }
            }
        break;
        }
    break;
    }
this->active=!(this->active);
this->type=get_inverse_action(this->type);
mainWin->mainArea->completeRedraw();
}

void undo_node::clearContents(void)
{
    int nr;
    linetype ** lt;
    boxtype ** bt;
    ellipsetype ** et;
    plotstr ** st;
    plotarr ** pa;
    graph ** gr;
    tickmarks ** tick;
    double * dd;
if (data!=NULL)
switch (type)
{
case UNDO_TYPE_PACK_SETS:
    pa=(plotarr**)data;
    for (int i=0;i<origin[2];i++)
    deleteSavedSet(pa[i],UNDO_COMPLETE);
break;
case UNDO_VIEWPORT_CHANGED:
    dd=(double*)data;
    delete[] dd;
break;
case UNDO_TYPE_PLOT_APPEARANCE:
    st=(plotstr**)data;
    delete st[0];
    delete st[1];
break;
case UNDO_TYPE_OBJECT_INSERTED:
case UNDO_TYPE_OBJECT_DELETED:
case UNDO_TYPE_OBJECT_MODIFIED:
if (type==UNDO_TYPE_OBJECT_MODIFIED)
nr=2*origin[2];
else
nr=origin[2];
    switch  (origin[1])//type
    {
    case OBJECT_BOX:
    bt=(boxtype**)data;
        for (int i=0;i<nr;i++)
        delete[] bt[i];
    break;
    case OBJECT_LINE:
    lt=(linetype**)data;
        for (int i=0;i<nr;i++)
        delete[] lt[i];
    break;
    case OBJECT_ELLIPSE:
    et=(ellipsetype**)data;
        for (int i=0;i<nr;i++)
        delete[] et[i];
    break;
    case OBJECT_STRING:
    st=(plotstr**)data;
        for (int i=0;i<nr;i++)
        {
        XCFREE(st[i]->s);
        delete[] st[i];
        }
    break;
    }
break;
case UNDO_TYPE_KILL_SET:
case UNDO_TYPE_NEW_SET:
case UNDO_TYPE_SET_APPEARANCE:
if (type==UNDO_TYPE_KILL_SET || type==UNDO_TYPE_NEW_SET)
nr=origin[2];
else
nr=origin[1]+origin[2];
    pa=(plotarr**)data;
    for (int i=0;i<nr;i++)
    deleteSavedSet(pa[i],origin[3]);
break;
case UNDO_TYPE_KILL_GRAPH:
case UNDO_TYPE_NEW_GRAPH:
case UNDO_TYPE_GRAPH_APPEARANCE:
if (type==UNDO_TYPE_KILL_GRAPH || type==UNDO_TYPE_NEW_GRAPH)
nr=origin[2];
else
nr=origin[1]+origin[2];
    gr=(graph**)data;
    for (int i=0;i<nr;i++)
    deleteSavedGraph(gr[i],origin[3]);
break;
case UNDO_TYPE_AXIS_PROPERTIES:
    tick=(tickmarks**)data;
nr=2*origin[2];
    for (int i=0;i<nr;i++)
    free_graph_tickmarks(tick[i]);
break;
//OTHER CASES
}
    type=UNDO_TYPE_INVALID;
    saved=active=multiple=false;
    savedFileName=AdditionalDescription=Description=QString();
    data=NULL;
    for (int i=0;i<MAX_DATA_IN_NODE;i++)
    {
    origin[i]=0;//invalid value
    if (id[i]!=NULL) delete[] id[i];
    id[i]=NULL;
    if (ddata[i]!=NULL) delete[] ddata[i];
    ddata[i]=NULL;
    }
    //origin[2]=0;//number of elements
}

QString undo_node::getDescription(void)
{
QString st("");

if (this_node_nr==nextUndoNode())
st+="U | ";
else if (this_node_nr==nextRedoNode())
st+="R | ";
else
st+="  | ";

if (active==false)
{
st+="(*) ";
}
st+=Description;
if (multiple==true)
{
st+=" (multiple)";
}
if (!AdditionalDescription.isEmpty())
{
st+=" ("+AdditionalDescription+")";
}
return st;
}

void invokeNewNode(int type,void ** data)
{
    switch (type)
    {
    case UNDO_TYPE_INVALID:
    break;
    case UNDO_TYPE_KILL_SET:
    break;
    case UNDO_TYPE_SET_MODIFIED:
    break;
    case UNDO_TYPE_SET_APPEARANCE:
    break;
    case UNDO_TYPE_GRAPH_APPEARANCE:
    break;
    case UNDO_TYPE_PLOT_APPEARANCE:
    break;
    case UNDO_TYPE_OBJECT_INSERTED:
    break;
    case UNDO_TYPE_OBJECT_MODIFIED:
    break;
    case UNDO_TYPE_PAGE_SETUP:
    break;
    case UNDO_TYPE_AXIS_PROPERTIES:
    break;
    case UNDO_TYPE_NEW_ORDERING:
    break;
    case UNDO_FIT:
    break;
    case UNDO_REGION:
    break;
    }
}

void ObjectsDeleted(int len,int * ids,int type)
{
undo_node * nn;
if (undo_active==false) return;

wait_till_update=true;
ObjectsCreated(len,ids,type);
wait_till_update=false;

nn=getPreviousNode();//go  back to set some stuff

nn->type=UNDO_TYPE_OBJECT_DELETED;//inverse action
nn->Description=nn->Description.replace(0,QObject::tr("Insert").size(),QObject::tr("Delete"));//inverse description

updateUndoList();
}

void ObjectsCreated(int len,int * ids,int type)
{
linetype ** lt;
boxtype ** bt;
ellipsetype ** et;
plotstr ** st;
undo_node * nn;
if (undo_active==false) return;
nn=getNextNode();
nn->clearContents();//to be on the save side
    if (len>1)
    {
    nn->multiple=true;
    }
    else
    {
    nn->multiple=false;
    }
nn->type=UNDO_TYPE_OBJECT_INSERTED;
nn->saved=false;
nn->origin[0]=ids[0];//which object was it?
nn->origin[1]=type;//what type of object was it?
nn->origin[2]=len;
nn->active=true;//active=false means: "already undone", active=true means: "ready to be undone"
nn->id[0]=new int[len];
    for (int i=0;i<len;i++)
    nn->id[0][i]=ids[i];
switch (type)
{
case OBJECT_BOX:
bt=new boxtype*[len];
nn->Description=QObject::tr("Insert Box");
    for (int i=0;i<len;i++)
    {
    bt[i]=new boxtype;
    memcpy(bt[i],boxes+ids[i],sizeof(boxtype));
    }
nn->data=(void*)bt;
break;
case OBJECT_LINE:
nn->Description=QObject::tr("Insert Line");
lt=new linetype*[len];
    for (int i=0;i<len;i++)
    {
    lt[i]=new linetype;
    memcpy(lt[i],lines+ids[i],sizeof(linetype));
    }
nn->data=(void*)lt;
    break;
case OBJECT_ELLIPSE:
nn->Description=QObject::tr("Insert Ellipse");
et=new ellipsetype*[len];
    for (int i=0;i<len;i++)
    {
    et[i]=new ellipsetype;
    memcpy(et[i],ellip+ids[i],sizeof(ellipsetype));
    }
nn->data=(void*)et;
break;
case OBJECT_STRING:
nn->Description=QObject::tr("Insert String");
st=new plotstr*[len];
    for (int i=0;i<len;i++)
    {
    st[i]=new plotstr;
    memcpy(st[i],pstr+ids[i],sizeof(plotstr));
        if (st[i]->s!=NULL)
        {
        st[i]->s=new char[strlen(pstr[ids[i]].s)+1];
        strcpy(st[i]->s,pstr[ids[i]].s);
        }
    }
nn->data=(void*)st;
break;
}
NextNode();//finish writing and prepare the next node
if (wait_till_update==false) updateUndoList();
}

void Undo(void)
{
if (UndoPossible()==false) return;
//cout << "Undo" << endl;
Node[akt_Node].reStoreData();//make the undo-command
if (akt_Node==0 && used_Nodes==max_node_nr)//wrap around has occured
{
    if (NodeNr==0)
    akt_Node=-1;//end reached
    else
    akt_Node=max_node_nr-1;
}
else if (akt_Node==NodeNr) akt_Node=-1;//end reached with wrap around
else akt_Node--;
CheckActive();
}

void Redo(void)
{
if (RedoPossible()==false) return;
//cout << "Redo" << endl;
if (akt_Node==-1 && used_Nodes>0)//Nodes present and Undo done a lot of times --> ReDo the first Node saved
{
    if (used_Nodes==max_node_nr)//wrap around has occured
    {
    akt_Node=NodeNr-1;
    Node[NodeNr].reStoreData();
    }
    else
    Node[0].reStoreData();
}
else
{
    if (akt_Node==max_node_nr-1)//next undo would be last in memory --> Redo would be first in memory (wrap around)
    Node[0].reStoreData();
    else
    Node[akt_Node+1].reStoreData();
}
akt_Node++;
if (akt_Node==max_node_nr) akt_Node=0;
CheckActive();
}

bool UndoPossible(void)
{
if (used_Nodes==0) return false;//no Nodes to Undo
    if (used_Nodes>0)
    {
        if (akt_Node==-1)
        return false;//everything has been made undone --> nothing left
        else
        return true;//akt_node>=0 --> there is a node that can be made undone
    }
    else
    {
    cout << "used_Nodes<0 !?" << endl;
    }
return false;
}

bool RedoPossible(void)
{
if (used_Nodes==0) return false;//no Nodes to Undo or Redo
    if (used_Nodes>0)
    {
        if ((akt_Node==NodeNr-1 && NodeNr>0) || (NodeNr==0 && akt_Node==max_node_nr-1))//nothing has been made undone yet --> nothing to redo
        return false;
        else
        return true;//akt_node>=0 --> there is a node that can be made undone
    }
    else
    {
    cout << "used_Nodes<0 !?" << endl;
    }
return false;
}

void CheckActive(void)
{
    /*cout << ">> NodeNr=" << NodeNr << endl;
    cout << "akt_Node=" << akt_Node << endl;
    cout << "used_Nodes=" << used_Nodes << endl;
    cout << "undo=" << UndoPossible() << "(" << nextUndoNode() << ")" << " redo=" << RedoPossible() << "(" << nextRedoNode() << ")" << endl;*/
    if (mainWin!=NULL)
    {
    mainWin->actUndo->setEnabled(UndoPossible());
    mainWin->actRedo->setEnabled(RedoPossible());
    }
    if (FormUndoList!=NULL)
    {
    FormUndoList->init();
    //if (FormUndoList->isVisible())
    FormUndoList->repaint();
    }
}

void PreviousNode(void)
{
    NodeNr--;//this will not change anything except the NodeNr
    if (NodeNr<0)
    {
    NodeNr=max_node_nr-1;
    }
}

void NextNode(void)//increase Nodes
{
    akt_Node=NodeNr;//the node that is to be undone next time is the one we wrote to this time!
    NodeNr++;
    used_Nodes++;
    if (used_Nodes>=max_node_nr)
    used_Nodes=max_node_nr;//used_nodes never greater then max_node_nr

    if (NodeNr>=max_node_nr) //wrap around
    {
    NodeNr=0;//next Node to write to is first Node in memory
    }
    CheckActive();
}

void initNodes(void)
{
if (Node==NULL) Node=new undo_node[MAX_UNDO_NODES];
    for (int i=0;i<MAX_UNDO_NODES;i++)
    {
    Node[i].clearContents();
    Node[i].this_node_nr=i;//necessary to know!
    }
NodeNr=0;
akt_Node=-1;//no active nodes, no undo, mo redo
used_Nodes=0;
max_node_nr=MAX_UNDO_NODES;
CheckActive();
}

undo_node * getPreviousNode(void)//get the node it has been last written to
{
undo_node * nn=NULL;
    if (used_Nodes==0)//this should never happen here!
    {
    nn=Node;//makes no sense!
    }
    else if (used_Nodes==max_node_nr)//all available space used
    {
        if (NodeNr==0)
        nn=Node+max_node_nr-1;
        else
        nn=Node+NodeNr-1;
    }
    else if (NodeNr>0 && NodeNr<max_node_nr)
    {
    nn=Node+NodeNr-1;
    }
    else
    {
    cout << "Error in getPreviousNode" << endl;
    cout << "NodeNr=" << NodeNr << endl;
    cout << "max_node_nr=" << max_node_nr << endl;
    cout << "used_Nodes=" << used_Nodes << endl;
    cout << "akt_Node=" << akt_Node << endl;
    }
return nn;
}

undo_node * getNextNode(void)//get Node to write into next
{
undo_node * nn=NULL;
    if (used_Nodes==0)
    nn=Node;//we start at the beginning
    else if (NodeNr>=0 && NodeNr<max_node_nr)
    nn=Node+NodeNr;
    else
    {
    cout << "Error in getNextNode" << endl;
    cout << "NodeNr=" << NodeNr << endl;
    cout << "max_node_nr=" << max_node_nr << endl;
    cout << "used_Nodes=" << used_Nodes << endl;
    cout << "akt_Node=" << akt_Node << endl;
    }
return nn;
}

int getNrOfNodes(void)
{
return used_Nodes;
}

QString getNodeDescription(int i)
{
return Node[index_translator(i)].getDescription();
}

int index_translator(int i)
{
static int j;
j=i;
if (used_Nodes<max_node_nr)//normal order
{
j=i;
}
else//wrap around occured
{
    if (NodeNr+i<max_node_nr)
    j=NodeNr+i;
    else
    j=NodeNr+i-max_node_nr;
}
return j;
}

int nextUndoNode(void)
{
static int ret;
ret=-1;
if (used_Nodes==0 || UndoPossible()==false)
ret=-1;
else
ret=akt_Node;
return ret;
}

int nextRedoNode(void)
{
static int ret;
ret=-1;
if (used_Nodes==0 || RedoPossible()==false) ret=-1;//nothing
else
{
ret=akt_Node+1;
if (akt_Node==-1 && used_Nodes==max_node_nr)
{
ret=NodeNr;
}
else if (akt_Node==-1)
{
ret=0;
}
if (ret==max_node_nr) ret=0;
if (akt_Node==NodeNr-1 && used_Nodes==max_node_nr && NodeNr>0) ret=-1;
}
return ret;
}

void SetsDeleted(int len,int * gnos,int * snos,int what)
{
if (undo_active==false) return;
undo_node * nn=getNextNode();
nn->clearContents();

nn->type=UNDO_TYPE_KILL_SET;
nn->active=true;
nn->Description=QObject::tr("Kill set");
    if (len>1)
    {
    nn->multiple=true;
    }
    else
    {
    nn->multiple=false;
    sprintf(dummy,"[G%d.S%d]",gnos[0],snos[0]);
    nn->Description+=QString(dummy);
    }
nn->origin[2]=len;
nn->origin[0]=gnos[0];
nn->origin[1]=snos[0];
nn->origin[3]=what;
nn->id[0]=new int[len];
nn->id[1]=new int[len];
memcpy(nn->id[0],gnos,len*sizeof(int));
memcpy(nn->id[1],snos,len*sizeof(int));
if (what==UNDO_DATA || what==UNDO_COMPLETE)
{
    plotarr ** pa=new plotarr*[len];
    for (int i=0;i<len;i++)
    {
    pa[i]=new plotarr;
    copySet(gnos[i],snos[i],pa[i],what);
    }
    nn->data=(void*) pa;
}
else
nn->data=NULL;

NextNode();//finish writing and prepare the next node
if (wait_till_update==false) updateUndoList();
}

void SetsCreated(int len,int * gnos,int * snos,int what)
{
if (undo_active==false) return;
wait_till_update=true;
SetsDeleted(len,gnos,snos,what);
wait_till_update=false;
undo_node * nn=getPreviousNode();//go  back to set some stuff

nn->type=UNDO_TYPE_NEW_SET;//inverse action
nn->Description=nn->Description.replace(0,QObject::tr("Kill").size(),QObject::tr("New"));//inverse description

updateUndoList();
}

void GraphsDeleted(int len,int * gnos,int what)
{
if (undo_active==false) return;
//int col;
undo_node * nn=getNextNode();
nn->clearContents();
graph ** gr=new graph*[len];
nn->type=UNDO_TYPE_KILL_GRAPH;
nn->active=true;
nn->Description=QObject::tr("Kill graph");
    if (len>1)
    {
    nn->multiple=true;
    }
    else
    {
    nn->multiple=false;
    sprintf(dummy,"[G%d]",gnos[0]);
    nn->Description+=QString(dummy);
    }
nn->origin[2]=len;
nn->origin[0]=gnos[0];
nn->origin[3]=what;
nn->id[0]=new int[len];
    for (int i=0;i<len;i++)
    {
    nn->id[0][i]=gnos[i];
    memcpy(gr[i],g+i,sizeof(graph));//copy set appearance
    for (int j=0;j<MAXAXES;j++)//copy tickmarks
    {
    gr[i]->t[j]=new tickmarks;
    memcpy(gr[i]->t[j],g[i].t[j],sizeof(tickmarks));
    }
        if (what==UNDO_DATA || what==UNDO_COMPLETE)
        {
            gr[i]->p=new plotarr[gr[i]->maxplot];//generate enought space for the sets
            for (int j=0;j<gr[i]->maxplot;j++)//go through all sets
            {
            copySet(gnos[i],j,gr[i]->p+j,what);
            }
        }
    }
nn->data=(void*)gr;

NextNode();//finish writing and prepare the next node
if (wait_till_update==false) updateUndoList();
}

void GraphsCreated(int len,int * gnos,int what)
{
if (undo_active==false) return;
wait_till_update=true;
GraphsDeleted(len,gnos,what);
wait_till_update=false;
undo_node * nn=getPreviousNode();//go  back to set some stuff

nn->type=UNDO_TYPE_NEW_GRAPH;//inverse action
nn->Description=nn->Description.replace(0,QObject::tr("Kill").size(),QObject::tr("New"));//inverse description

updateUndoList();
}

void copySet(int gno,int setno,plotarr * pa,int what)
{
int i;
int cols;
if (!is_valid_setno(gno, setno)) return;
memcpy(pa,g[gno].p+setno,sizeof(plotarr));//copy the whole plotarr! --> always copy this!
//only the actual address of the set is coppied --> copy contents as well
cols=settype_cols(pa->type);

if (what==UNDO_COMPLETE || what==UNDO_DATA)//do not copy data if only appearance is asked
{
for (i=0;i<cols;i++)//copy coulmns
{
pa->data.ex[i]=new double[pa->data.len];
///g[gno].p[setno].data.ex[i] = (double *)xrealloc(g[gno].p[setno].data.ex[i],pa->data.len*sizeof(double));
memcpy(pa->data.ex[i],g[gno].p[setno].data.ex[i],pa->data.len*sizeof(double));
}
if (pa->data.s!=NULL)//copy strings
{
pa->data.s = new char*[pa->data.len];
    for (i=0;i<pa->data.len;i++)
    {
    pa->data.s[i]=new char[strlen(g[gno].p[setno].data.s[i]) + 1];
    strcpy(pa->data.s[i], g[gno].p[setno].data.s[i]);
    }
}
}

}

void deleteSavedSet(plotarr * pa,int what)//clear all entries including the deep copy of the data
{
int i;
int cols;
if (pa==NULL) return;
cols=settype_cols(pa->type);
if (what==UNDO_COMPLETE || what==UNDO_DATA)//do not delete data if only appearance is asked (because not data has been allocated)
{
    for (i=0;i<cols;i++)//copy coulmns
    delete[] pa->data.ex[i];
    if (pa->data.s!=NULL)
    {
        for (i=0;i<pa->data.len;i++)
        delete[] pa->data.s[i];
    delete[] pa->data.s;
    }
}
delete pa;
pa=NULL;
}

///TODO checken, ob man nicht vielleicht die xrealloc's mit der ex-Adresse machen koennte--> d.h. die vorher gesicherte Adresse vor dem copy!
void reinstallSet(int gno,int setno,plotarr * pa,int what)
{
int i;
int cols,old_cols;
bool activ;
bool valid=is_valid_setno(gno,setno);
if (valid==FALSE)
{
cout << "invalid set: G" << gno << ".S" << setno << ", unable to restore yet" << endl;
return;
}
old_cols=dataset_cols(gno, setno);
char ** sav_s=g[gno].p[setno].data.s;
double * sav_ex[MAX_SET_COLS];
memcpy(sav_ex,g[gno].p[setno].data.ex,sizeof(double*)*MAX_SET_COLS);

/*char ** ssav2=new char*[g[gno].p[setno].data.len];
for (int i=0;i<MAX_SET_COLS;i++)
sav[i]=g[gno].p[setno].data.ex[i];
for (int i=0;i<g[gno].p[setno].data.len;i++)
ssav2[i]=g[gno].p[setno].data.s[i];
*/
if (pa==NULL) return;//there is nothing to reinstall
cols=settype_cols(pa->type);
activ=is_set_active(gno,setno);
if (valid==false)//set completely new -- should not happen, because we are talking about undo and a deleted has been existend in the past
{
    cout << "invalid set: G" << gno << ".S" << setno << ", unable to restore yet" << endl;
}
else//set exists or has existed (in any way: memory already allocated)
{
    if (what!=UNDO_DATA)//data only means: do not reinstall appearance
    memcpy(g[gno].p+setno,pa,sizeof(plotarr));

    //do not override data (at first)
    g[gno].p[setno].data.s=sav_s;
    memcpy(g[gno].p[setno].data.ex,sav_ex,sizeof(double*)*MAX_SET_COLS);

        /*for (int i=0;i<MAX_SET_COLS;i++)
        g[gno].p[setno].data.ex[i]=sav[i];
        g[gno].p[setno].data.s=ssav;
        for (int i=0;i<g[gno].p[setno].data.len;i++)
        g[gno].p[setno].data.s[i]=ssav2[i];*/

    if (what!=UNDO_APPEARANCE)//appearance only means: do not reinstall data
    {
    g[gno].p[setno].data.len=pa->data.len;//in case no copy of appearance has been done
    ///set_dataset_type(gno,setno,pa->type);
    ///setlength(gno,setno,pa->data.len);
    for (i=0;i<cols;i++)//copy coulmns
    {
        //g[gno].p[setno].data.ex[i] = (double *)xrealloc(g[gno].p[setno].data.ex[i],pa->data.len*sizeof(double));
        /*if (g[gno].p[setno].data.ex[i]!=NULL)
        XCFREE(g[gno].p[setno].data.ex[i]);*/
    g[gno].p[setno].data.ex[i] = (double *)xrealloc(g[gno].p[setno].data.ex[i],pa->data.len*sizeof(double));//should work now without NULL
    memcpy(g[gno].p[setno].data.ex[i],pa->data.ex[i],pa->data.len*sizeof(double));
    }
    for (i = cols; i < old_cols; i++)
    {
        XCFREE(g[gno].p[setno].data.ex[i]);
    }
        if (pa->data.s!=NULL)//copy strings
        {
        g[gno].p[setno].data.s = (char**)xrealloc(g[gno].p[setno].data.s , (pa->data.len)*sizeof(char*));
            for (i=0;i<pa->data.len;i++)
            {
            g[gno].p[setno].data.s[i]=(char*)xrealloc(g[gno].p[setno].data.s[i], (strlen(pa->data.s[i]) + 1)*sizeof(char));
            ///strcpy(g[gno].p[setno].data.s[i],pa->data.s[i]);
            g[gno].p[setno].data.s[i]=copy_string(g[gno].p[setno].data.s[i],pa->data.s[i]);
            }
        }
    }
}

}

void copyGraph(int gno,graph * gr,int what)//we assume, that gr has ben allocated
{
    if (what==UNDO_COMPLETE || what==UNDO_APPEARANCE)
    {
    memcpy(gr,g+gno,sizeof(graph));//copy set appearance
    gr->labs.title.s=copy_string(NULL,g[gno].labs.title.s);
    gr->labs.stitle.s=copy_string(NULL,g[gno].labs.stitle.s);
    }
if (what==UNDO_COMPLETE || what==UNDO_AXIS)
{
for (int j=0;j<MAXAXES;j++)//copy tickmarks
gr->t[j]=copy_graph_tickmarks(g[gno].t[j]);
}
    if (what==UNDO_DATA || what==UNDO_COMPLETE)
    {
    gr->p=new plotarr[g[gno].maxplot];//generate enough space for the sets
    for (int j=0;j<g[gno].maxplot;j++)//go through all sets
    copySet(gno,j,gr->p+j,what);
    }
}

void deleteSavedGraph(graph * gr,int what)
{
    if (gr==NULL) return;
    if (what==UNDO_DATA || what==UNDO_COMPLETE)
    {
        for (int j=0;j<gr->maxplot;j++)//go through all sets
        deleteSavedSet(gr->p+j,what);
    delete[] gr->p;//delete plotarr
    }
        if (what==UNDO_APPEARANCE || what==UNDO_COMPLETE)
        {
        XCFREE(gr->labs.title.s);
        XCFREE(gr->labs.stitle.s);
        }
    if (what==UNDO_COMPLETE || what==UNDO_AXIS)
    {
        for (int j = 0; j < MAXAXES; j++)
        free_graph_tickmarks(gr->t[j]);
    delete gr->t;//delete tickmarks
    }
    delete gr;//delete all memory
    gr=NULL;
}

void reinstallGraph(int gno,graph * gr,int what)//you have to make sure that gno is valid / exists
{
    if (gr==NULL) return;
int valid=is_valid_gno(gno);
///int activ=is_active_gno()
int stat=graph_allocate(gno);
if (valid==false)
{
///cout << "gno=" << gno << " invalid" << endl;
    if (stat==RETURN_FAILURE)
    {
    cout << "Error! Could not allocate new grpah!" << endl;
    return;
    }
}

    /*
    if (what==UNDO_COMPLETE || what==UNDO_AXIS)
    for (int j=0;j<MAXAXES;j++)//copy tickmarks
    free_graph_tickmarks(g[gno].t[j]);
    */

tickmarks *t[MAXAXES];
memcpy(t,g[gno].t,sizeof(tickmarks*)*MAXAXES);//save tickmarks adresses
plotarr * pl=g[gno].p;

    if (what==UNDO_COMPLETE || what==UNDO_APPEARANCE)
    {
    memcpy(g+gno,gr,sizeof(graph));//copy graph appearance
    g[gno].labs.title.s=copy_string(NULL,gr->labs.title.s);
    g[gno].labs.stitle.s=copy_string(NULL,gr->labs.stitle.s);
    }
if (what==UNDO_APPEARANCE)//reinstall tickmark_adresses, because appearance doers not mean tickmarks
{
memcpy(g[gno].t,t,sizeof(tickmarks*)*MAXAXES);
g[gno].p=pl;
}
    if (what==UNDO_COMPLETE || what==UNDO_AXIS)
    {
        for (int j=0;j<MAXAXES;j++)//copy tickmarks
        {
        g[gno].t[j]=copy_graph_tickmarks(gr->t[j]);
        }
    }
if (what==UNDO_DATA || what==UNDO_COMPLETE)
{
kill_all_sets(gno);
realloc_graph_plots(gno,gr->maxplot);
for (int j=0;j<gr->maxplot;j++)//go through all sets
copySet(gno,j,gr->p+j,what);
}
}

int get_inverse_action(int i)
{
static int inv;
if (abs(i)<100)//possible inverse
{
inv=-i;
}
else
{
inv=i;//inverse is the same action (previous / after)
}
return inv;
}

bool isNodeActive(int i)
{
return Node[i].active;
}

void RestoreNode(int i)
{
Node[index_translator(i)].reStoreData();
}

void updateUndoList(void)
{
if (FormUndoList!=NULL)
FormUndoList->init();
}

void addAditionalDescriptionToLastNode(int type,QString description,QString additional)
{
undo_node * nn=getPreviousNode();
nn->type=type;
    if (!description.isEmpty())
    nn->Description=description;
nn->AdditionalDescription=additional;
}

void SaveSetStatesPrevious(int len,int * gnos,int * snos,int what)
{
if (undo_active==false) return;
    if (prev_sets!=NULL)
    {
    for (int i=0;i<saved_prev_sets;i++)
    deleteSavedSet(prev_sets[i],what);
    delete[] prev_sets;
    prev_sets=NULL;
    }
if (len>0)
{
    prev_sets=new plotarr*[len];
    if (old_idata[0]!=NULL) delete[] old_idata[0];
    if (old_idata[1]!=NULL) delete[] old_idata[1];
    old_idata[0]=new int[len];
    old_idata[1]=new int[len];
    memcpy(old_idata[0],gnos,len*sizeof(int));
    memcpy(old_idata[1],snos,len*sizeof(int));

        for (int i=0;i<len;i++)
        {
        prev_sets[i]=new plotarr;
        copySet(gnos[i],snos[i],prev_sets[i],what);
        }
}
    saved_prev_sets=len;
}

void SetsModified(int len,int * gnos,int * snos,int what)
{
if (undo_active==false) return;
undo_node * nn=getNextNode();
nn->clearContents();
nn->active=true;
if (what==UNDO_APPEARANCE)
{
nn->type=UNDO_TYPE_SET_APPEARANCE;
nn->Description=QObject::tr("Set appearance changed");
}
else
{
nn->type=UNDO_TYPE_SET_MODIFIED;
nn->Description=QObject::tr("Set modified");
}
    if (len>1 || saved_prev_sets>1)
    {
    nn->multiple=true;
    }
    else
    {
    nn->multiple=false;
    sprintf(dummy,"[G%d.S%d]",gnos[0],snos[0]);
    nn->Description+=QString(dummy);
    }
nn->origin[2]=len;//number of sets after modification
nn->origin[0]=gnos[0];//no one is actually using this!
nn->origin[1]=saved_prev_sets;//number of sets in first go
nn->origin[3]=what;
nn->id[0]=new int[len+saved_prev_sets];
nn->id[1]=new int[len+saved_prev_sets];
memcpy(nn->id[0],old_idata[0],saved_prev_sets*sizeof(int));
memcpy(nn->id[1],old_idata[1],saved_prev_sets*sizeof(int));
if (old_idata[0]!=NULL)
{
delete[] old_idata[0];
old_idata[0]=NULL;
}
if (old_idata[1]!=NULL)
{
delete[] old_idata[1];
old_idata[1]=NULL;
}
memcpy(nn->id[0]+saved_prev_sets,gnos,len*sizeof(int));
memcpy(nn->id[1]+saved_prev_sets,snos,len*sizeof(int));

plotarr ** pa=new plotarr*[len+saved_prev_sets];
    for (int i=0;i<saved_prev_sets;i++)
    {
    pa[i]=prev_sets[i];//previous
    prev_sets[i]=NULL;//don't delete this next time!
    }
    for (int i=saved_prev_sets;i<saved_prev_sets+len;i++)
    {
    pa[i]=new plotarr;//allocate memory
    copySet(gnos[i-saved_prev_sets],snos[i-saved_prev_sets],pa[i],what);//after
    }
nn->data=(void*)pa;
NextNode();//finish writing and prepare the next node
updateUndoList();
}

void SaveGraphStatesPrevious(int len,int * gnos,int what)
{
if (undo_active==false) return;
if (prev_graphs!=NULL)
{
for (int i=0;i<saved_prev_graphs;i++)
deleteSavedGraph(prev_graphs[i],what);
delete[] prev_graphs;
}
prev_graphs=new graph*[len];
old_idata[0]=new int[len];
memcpy(old_idata[0],gnos,len*sizeof(int));
saved_prev_graphs=len;
    for (int i=0;i<len;i++)
    {
    prev_graphs[i]=new graph;
    copyGraph(gnos[i],prev_graphs[i],what);
    }
}

void GraphsModified(int len,int * gnos,int what)
{
if (undo_active==false) return;
undo_node * nn=getNextNode();
nn->clearContents();
nn->active=true;
nn->type=UNDO_TYPE_GRAPH_APPEARANCE;
nn->Description=QObject::tr("Graph appearance changed");
    if (len>1)
    {
    nn->multiple=true;
    }
    else
    {
    nn->multiple=false;
    sprintf(dummy,"[G%d]",gnos[0]);
    nn->Description+=QString(dummy);
    }
nn->origin[2]=len;
nn->origin[1]=saved_prev_graphs;
nn->origin[0]=gnos[0];
nn->origin[3]=what;
nn->id[0]=new int[len+saved_prev_graphs];
memcpy(nn->id[0],old_idata[0],saved_prev_graphs*sizeof(int));
old_idata[0]=NULL;
memcpy(nn->id[0]+saved_prev_graphs,gnos,len*sizeof(int));
graph ** pa=new graph*[len+saved_prev_graphs];//'*2' because: previous and after!
    for (int i=0;i<saved_prev_graphs;i++)
    {
    pa[i]=prev_graphs[i];//previous
    prev_graphs[i]=NULL;//don't delete this next time!
    }
    for (int i=saved_prev_graphs;i<saved_prev_graphs+len;i++)
    {
    pa[i]=new graph;//allocate new memory
    copyGraph(gnos[i-saved_prev_graphs],pa[i],what);//after
    }
nn->data=(void*)pa;
NextNode();//finish writing and prepare the next node
updateUndoList();
}

void SaveTickmarksStatesPrevious(int axis_start,int axis_stop,int graph_start,int graph_stop)
{
if (undo_active==false) return;
int counter=(graph_stop-graph_start+1)*(axis_stop-axis_start+1);
if (counter<1) return;
world w;
for (int i=0;i<4;i++)
{
old_ddata[i]=new double[counter];
old_idata[i]=new int[counter];
}
    if (prev_tickmarks!=NULL)
    {
        cout << "freeing" << endl;
    for (int i=0;i<saved_prev_tickmarks;i++)
    free_graph_tickmarks(prev_tickmarks[i]);
    delete[] prev_tickmarks;
    }
    saved_prev_tickmarks=counter;
    prev_tickmarks=new tickmarks*[counter];//only enough space for pointers
    counter=0;
    for (int i=graph_start;i<=graph_stop;i++)
    {
        get_graph_world(i, &w);
        for (int j=axis_start;j<=axis_stop;j++)
        {
        prev_tickmarks[counter]=copy_graph_tickmarks(g[i].t[j]);//deep copy of all contents
        old_ddata[0][counter]=w.xg1;
        old_ddata[1][counter]=w.xg2;
        old_ddata[2][counter]=w.yg1;
        old_ddata[3][counter]=w.yg2;
        old_idata[0][counter]=get_graph_xscale(i);
        old_idata[1][counter]=get_graph_yscale(i);
        old_idata[2][counter]=is_graph_xinvert(i);
        old_idata[3][counter]=is_graph_yinvert(i);
        counter++;
        }
    }
}

void TickmarksModified(int axis_start,int axis_stop,int graph_start,int graph_stop)
{
if (undo_active==false) return;
int counter=(graph_stop-graph_start+1)*(axis_stop-axis_start+1);
if (counter<1) return;
world w;
undo_node * nn=getNextNode();
nn->clearContents();
nn->active=true;
nn->type=UNDO_TYPE_AXIS_PROPERTIES;
nn->Description=QObject::tr("Axis properties changed");
    if (counter>1)
    {
    nn->multiple=true;
    }
    else
    {
    nn->multiple=false;
    sprintf(dummy,"[G%d.",graph_start);
    nn->Description+=QString(dummy);
        if (axis_start==0)
        nn->Description+=QObject::tr("X-axis");
        else if (axis_start==1)
        nn->Description+=QObject::tr("Y-axis");
        else if (axis_start==2)
        nn->Description+=QObject::tr("Alt-X-axis");
        else if (axis_start==3)
        nn->Description+=QObject::tr("Alt-Y-axis");
    nn->Description+=QString("]");
    }
nn->origin[2]=counter;//important
nn->origin[0]=axis_start;
nn->origin[1]=axis_stop;
nn->origin[3]=graph_start;
nn->id[0]=new int[4];//save axis numbers concerned
nn->id[0][0]=axis_start;
nn->id[0][1]=axis_stop;
nn->id[0][2]=graph_start;
nn->id[0][3]=graph_stop;
nn->id[1]=new int[4*(counter*2)+4];//4 integer entries per counter (xscale,yscale,xinvert,yinvert)
for (int i=0;i<4;i++)
nn->ddata[i]=new double[counter*2];
tickmarks ** t_tickmarks=new tickmarks*[counter*2];//'*2' because: previous and after
counter=0;
for (int i=graph_start;i<=graph_stop;i++)
{
    for (int j=axis_start;j<=axis_stop;j++)
    {
    t_tickmarks[counter]=prev_tickmarks[counter];//copy pointer only
    prev_tickmarks[counter]=NULL;//do not delete this next time!
        for (int k=0;k<4;k++)
        {
        nn->ddata[k][counter]=old_ddata[k][counter];
        nn->id[1][4*counter+k]=old_idata[k][counter];
        }
    counter++;
    }//save previous states
}
delete[] prev_tickmarks;
prev_tickmarks=NULL;
saved_prev_tickmarks=0;
    for (int i=graph_start;i<=graph_stop;i++)
    {
        get_graph_world(i, &w);
        for (int j=axis_start;j<=axis_stop;j++)
        {
        t_tickmarks[counter]=copy_graph_tickmarks(g[i].t[j]);//copy new states
        nn->ddata[0][counter]=w.xg1;
        nn->ddata[1][counter]=w.xg2;
        nn->ddata[2][counter]=w.yg1;
        nn->ddata[3][counter]=w.yg2;
        nn->id[1][4*counter+0]=get_graph_xscale(i);
        nn->id[1][4*counter+1]=get_graph_yscale(i);
        nn->id[1][4*counter+2]=is_graph_xinvert(i);
        nn->id[1][4*counter+3]=is_graph_yinvert(i);
        counter++;
        }
    }
nn->data=(void*)t_tickmarks;
NextNode();//finish writing and prepare the next node
    for (int i=0;i<4;i++)
    {
    delete[] old_ddata[i];
    delete[] old_idata[i];
    }
}

void SavePlotAppearance(void)
{
if (undo_active==false) return;
old_data[0]=draw_props.bgcolor;
old_data[1]=draw_props.bgfilled;
if (old_tmstmp==NULL) old_tmstmp=new plotstr;
memcpy(old_tmstmp,&timestamp,sizeof(plotstr));//remember: this will copy the adress of the string as well --> string should not be made undone!
}

void PlotAppearanceModified(void)
{
if (undo_active==false) return;
undo_node * nn=getNextNode();
nn->clearContents();
nn->active=true;
nn->type=UNDO_TYPE_PLOT_APPEARANCE;
nn->Description=QObject::tr("Plot appearance changed");
nn->multiple=false;
nn->origin[0]=old_data[0];
nn->origin[1]=old_data[1];
nn->origin[2]=draw_props.bgcolor;
nn->origin[3]=draw_props.bgfilled;
plotstr ** tmstmp=new plotstr*[2];
tmstmp[0]=old_tmstmp;
tmstmp[1]=new plotstr;
old_tmstmp=NULL;
memcpy(tmstmp[1],&timestamp,sizeof(plotstr));//remember: this will copy the adress of the string as well --> string should not be made undone!
nn->data=(void*)tmstmp;
NextNode();//finish writing and prepare the next node
updateUndoList();
}

void SaveObjectData(int id,int type)
{
if (undo_active==false) return;
switch (type)
{
case OBJECT_BOX:
    if (sav_bt!=NULL) delete sav_bt;
    sav_bt=new boxtype;
    memcpy(sav_bt,boxes+id,sizeof(boxtype));
break;
case OBJECT_LINE:
    if (sav_lt!=NULL) delete sav_lt;
    sav_lt=new linetype;
    memcpy(sav_lt,lines+id,sizeof(linetype));
break;
case OBJECT_ELLIPSE:
    if (sav_et!=NULL) delete sav_et;
    sav_et=new ellipsetype;
    memcpy(sav_et,ellip+id,sizeof(ellipsetype));
break;
case OBJECT_STRING:
    if (sav_st!=NULL) delete sav_st;
    sav_st=new plotstr;
    memcpy(sav_st,pstr+id,sizeof(plotstr));//copy plotstr
        if (sav_st->s!=NULL)//copy the actual string/text
        {
        sav_st->s=new char[strlen(pstr[id].s)+1];
        strcpy(sav_st->s,pstr[id].s);
        }
break;
}
}

void ObjectDataModified(int id,int type)
{
if (undo_active==false) return;
undo_node * nn=getNextNode();
linetype ** lt;
boxtype ** bt;
ellipsetype ** et;
plotstr ** st;
nn->clearContents();
nn->active=true;
nn->type=UNDO_TYPE_OBJECT_MODIFIED;
nn->Description=QObject::tr("Object edited");
nn->multiple=false;
nn->origin[0]=id;
nn->origin[1]=type;
switch (type)
{
case OBJECT_BOX:
    bt=new boxtype*[2];//'2' = previous + after
    nn->Description=QObject::tr("Box edited");
    bt[0]=sav_bt;
    sav_bt=NULL;
    bt[1]=new boxtype;
    memcpy(bt[1],boxes+id,sizeof(boxtype));
    nn->data=(void*)bt;
break;
case OBJECT_LINE:
    lt=new linetype*[2];
    nn->Description=QObject::tr("Line edited");
    lt[0]=sav_lt;
    sav_lt=NULL;
    lt[1]=new linetype;
    memcpy(lt[1],lines+id,sizeof(linetype));
    nn->data=(void*)lt;
break;
case OBJECT_ELLIPSE:
    et=new ellipsetype*[2];
    nn->Description=QObject::tr("Ellipse edited");
    et[0]=sav_et;
    sav_et=NULL;
    et[1]=new ellipsetype;
    memcpy(et[1],ellip+id,sizeof(ellipsetype));
    nn->data=(void*)et;
break;
case OBJECT_STRING:
    st=new plotstr*[2];
    nn->Description=QObject::tr("String edited");
    st[0]=sav_st;
    sav_st=NULL;
    st[1]=new plotstr;
    memcpy(st[1],pstr+id,sizeof(plotstr));
        if (st[1]->s!=NULL)
        {
        st[1]->s=new char[strlen(pstr[id].s)+1];
        strcpy(st[1]->s,pstr[id].s);
        }
    nn->data=(void*)st;
break;
}
NextNode();//finish writing and prepare the next node
updateUndoList();
}

void UndoSwapGraphs(int g1,int g2)
{
if (undo_active==false) return;
undo_node * nn=getNextNode();
nn->clearContents();
nn->active=true;
nn->type=UNDO_TYPE_GRAPH_SWAP;
nn->Description=QObject::tr("Graphs swapped");
sprintf(dummy,"[G%d<->G%d]",g1,g2);
nn->Description+=QString(dummy);
nn->multiple=false;
nn->origin[0]=g1;
nn->origin[1]=UNDO_GRAPH;
nn->origin[2]=1;
nn->origin[3]=g2;
//no additional data needed here! No data is destroyed!
NextNode();//finish writing and prepare the next node
updateUndoList();
}

void UndoSwapSets(int g1,int s1,int g2,int s2)
{
if (undo_active==false) return;
undo_node * nn=getNextNode();
nn->clearContents();
nn->active=true;
nn->type=UNDO_TYPE_SET_SWAP;
nn->Description=QObject::tr("Sets swapped");
sprintf(dummy,"[G%d.S%d<->G%d.S%d]",g1,s1,g2,s2);
nn->Description+=QString(dummy);
nn->multiple=false;
//just use the available space --> no need to allocate more space
nn->origin[0]=g1;
nn->origin[1]=s1;
nn->origin[2]=g2;
nn->origin[3]=s2;
//no additional data needed here! No data is destroyed!
NextNode();//finish writing and prepare the next node
updateUndoList();
}

void SetsAboutToBePacked(int gno)
{
if (undo_active==false) return;
undo_node * nn=getNextNode();
nn->clearContents();
nn->active=true;
nn->type=UNDO_TYPE_SET_SWAP;
nn->Description=QObject::tr("Sets packed");
sprintf(dummy,"[G%d]",gno);
nn->Description+=QString(dummy);
nn->multiple=false;
nn->origin[0]=gno;
nn->origin[1]=UNDO_SET;
nn->origin[2]=g[gno].maxplot;
/*
int nr_active=0;
nn->id[0]=new int[nn->origin[2]];
nn->id[1]=new int[nn->origin[2]];
for (int i=0;i<nn->origin[2];i++)
{
if (is_set_active(gno,i))
{
nn->id[0][nr_active++]=i;//save old set order
}
}
nn->origin[3]=nr_active;
*/
//All sets have to bee saved, because the inactive sets are lost
plotarr ** pa=new plotarr*[nn->origin[2]];
for (int i=0;i<nn->origin[2];i++)
{
    pa[i]=new plotarr;
    copySet(gno,i,pa[i],UNDO_COMPLETE);
}
nn->data=(void*)pa;
NextNode();//finish writing and prepare the next node
updateUndoList();
}

void ViewportChanged(int gno,view v)
{
if (undo_active==false || !is_valid_gno(gno)) return;
undo_node * nn=getNextNode();
nn->clearContents();
nn->active=true;
nn->type=UNDO_VIEWPORT_CHANGED;
nn->Description=QObject::tr("Graph viewport changed");
sprintf(dummy,"[G%d]",gno);
nn->Description+=QString(dummy);
nn->multiple=false;
nn->origin[0]=gno;
nn->origin[2]=1;
double * views=new double[8];
view old_v;
get_graph_viewport(gno,&old_v);
views[0]=old_v.xv1;
views[1]=old_v.xv2;
views[2]=old_v.yv1;
views[3]=old_v.yv2;
views[4]=v.xv1;
views[5]=v.xv2;
views[6]=v.yv1;
views[7]=v.yv2;
nn->data=(void*)views;
NextNode();//finish writing and prepare the next node
updateUndoList();
}

int contains(int * list,int len,int number)
{
int ret=-1;
for (int i=0;i<len;i++)
{
    if (list[i]==number)
    {
    ret=i;
    break;
    }
}
return ret;
}
